import java.util.*;

public class Hanoi1 {

    private final static int NUMBER_OF_TOWERS = 3; // ̖{

    private final static int START = 0;  // Jn
    private final static int END = 1;    // I

    private int size;                    // ̃TCY
    private Player player;

    public Hanoi1(int size){
        this.size = size;
        
        player = new Player();
    }

    // Q[̃C[`
    public void startGame(){
        List towers = makeTowers();

        System.out.println("nmC̓");
        printTowers(towers);
        System.out.println(START + "  " + END + " ֈړĂ\n");

        do{
            PileMovementInfo pileMovementInfo = player.nextStep(towers);

            movePile(towers, pileMovementInfo.getSource(), pileMovementInfo.getDestination());
            printTowers(towers);
        }while(!checkCompletion(towers, END));

        System.out.println("܂\n߂łƂ܂");
    }

    // ~Ղ̈ړ
    private void movePile(List towers, int source, int destination){
        Stack tower = (Stack)towers.get(source);
        Integer diameter = (Integer)tower.pop();
        tower = (Stack)towers.get(destination);
        tower.push(diameter);
    }

    // nmC̓̐
    private List makeTowers(){
        List towers = new ArrayList();

        for(int i = 0 ; i < NUMBER_OF_TOWERS ; i++){
            towers.add(new Stack());
        }

        for(int i = size ; i > 0 ; i--){
            ((Stack)towers.get(START)).push(new Integer(i));
        }

        return towers;
    }
        
    // I`FbN
    private boolean checkCompletion(List towers, int goal){
        // ړ̓̉~Ղ̖~Ղ̑ƓłΊ
        Stack tower = (Stack)towers.get(goal);
        if(tower.size() == size){
            return true;
        }else{
            return false;
        }
    }

    // nmC̓̕`
    private void printTowers(List towers){
        System.out.println("");

        // Stack 𑀍삷邽߂ɃN[
        List tempTowers = new ArrayList();
        for(int i = 0 ; i < NUMBER_OF_TOWERS ; i++){
            Stack tower = (Stack)towers.get(i);
            tempTowers.add(tower.clone());
        }
            
        for(int i = size ; i > 0 ; i--){
            for(int j = 0 ; j < NUMBER_OF_TOWERS ; j++){
                Stack tower = (Stack)tempTowers.get(j);
                if(tower.size() >= i){
                    // ɂĂ~Ղ`
                    int diameter = ((Integer)(tower.pop())).intValue();

                    for(int k = 0 ; k < size - diameter ; k++){
                        System.out.print(" ");
                    }
                    for(int k = 0 ; k < 2*diameter -1 ; k++){
                        System.out.print("*");
                    }
                    for(int k = 0 ; k < size - diameter ; k++){
                        System.out.print(" ");
                    }
                }else{
                    // ~ՂȂ̂œ`
                    for(int k = 0 ; k < size-1 ; k++){
                        System.out.print(" ");
                    }
                    System.out.print("|");
                    for(int k = 0 ; k < size-1 ; k++){
                        System.out.print(" ");
                    }
                }

                System.out.print("  ");
            }
            System.out.println("");
        }

        // ̕`
        for(int i = 0 ; i < 3 ; i++){
            for(int j = 0 ; j < 2 * size - 1 ; j++){
                System.out.print("~");
            }
            System.out.print("  ");
        }
        System.out.println("");

        // ̔ԍ`
        for(int i = 0 ; i < 3 ; i++){
            for(int j = 0 ; j < size-1 ; j++){
                System.out.print(" ");
            }
            System.out.print(i);
            for(int j = 0 ; j < size-1 ; j++){
                System.out.print(" ");
            }
            System.out.print("  ");
        }
        System.out.println("\n");

    }

    public static void main(String[] args){
        if(args.length < 1){
            System.out.println("Usage: java Hanoi [~Ղ̖]");
            return;
        }

        Hanoi1 hanoi = new Hanoi1(Integer.parseInt(args[0]));
        hanoi.startGame();
    }
}
